//  support function for MOS
//      1 Apr 2016,  no it is not April Fool

#include "s21.h"

/*   data in S2 space

global variables

nump
currentp

process queue  size 16 words

process control block
struct { PC, SP, ... }   size 16 words

stack of each process size 64 words

memory map

0...900    code
1000       int vec
1500       global var
2000       process queue
2100       process control block
2300       stack

nump      1500
currentp  1501

*/

extern int M[];

#define nump   M[1500]

//  queue, Stack are in C space
int Q[16];
int qindex = 0;				// index into Q
int pcbptr = 2100; 			// for pcb alloc
int stackptr = 2300;		// for stack alloc

int newp(void){
	int a;
	a = pcbptr;
	pcbptr += 16;
	return a;
}

int newStack(void){
	int a;
	a = stackptr;
	stackptr += 64;
	return a;
}

//  Q is an array of PCB pointer
//    nump  keeps the number of process
//    Q[.] = 0    the end of queue
//    Q[.] = 1    terminated state of process
//    Q[qindex]   pointer to current process

void enqueue(int p){
	int i;
	i = 0;
	while(Q[i] != 0) 	// find end of Q
		i++;
	Q[i] = p;
	Q[i+1] = 0;
	nump++;
}

void terminate(void){
	Q[qindex] = 1;
	nump--;
}

//  return 0 if no process in the queue
int nextp(void){
	if(nump == 0) return 0;
	qindex++;
	while( Q[qindex] == 1 || Q[qindex] == 0 ){
		if(Q[qindex] == 0) qindex = 0;
		if(Q[qindex] == 1) qindex++;
	}
	return Q[qindex];
}
